/*
Przygotowanie bazy danych 

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null primary key, Nazwa varchar(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int references Jednostka(ID), Imie varchar(30), Nazwisko varchar(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

select * from Osoba o, Jednostka j where o.ID_Jednostka = j.ID; 

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using Oracle.DataAccess.Client;
using System.Configuration;

namespace ConnectionExample
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                OracleConnection oraconnection = new OracleConnection("Data Source=XE;User Id=pawel;Password=oracle10g");
                OracleCommand oracmd = new OracleCommand("SELECT Nazwisko, Imie FROM Osoba", oraconnection);
                oraconnection.Open();
                OracleDataReader orareader = oracmd.ExecuteReader();
                while (orareader.Read())
                {
                    Console.WriteLine("{0} {1}", orareader.GetString(0), orareader.GetString(1));
                }
                oraconnection.Close();


                SqlConnection connection = new SqlConnection("Data Source=DRACULA\\SQLEXPRESS;Initial Catalog=KursPBD;Integrated Security=true");
                SqlCommand cmd = new SqlCommand("SELECT Nazwisko, Imie FROM Osoba", connection);
                connection.Open();
                SqlDataReader reader = cmd.ExecuteReader();
                while (reader.Read())
                {
                    Console.WriteLine("{0} {1}", reader.GetString(0), reader.GetString(1));
                }
                connection.Close();

                //IDbConnection iconnection = new OracleConnection(ConfigurationManager.AppSettings["oracleconnectionstring"]);
                IDbConnection iconnection = new SqlConnection(ConfigurationManager.AppSettings["sqlconnectionstring"]);
                IDbCommand icmd = iconnection.CreateCommand();
                icmd.CommandText = "SELECT Nazwisko, Imie FROM Osoba";
                icmd.Connection = iconnection;
                iconnection.Open();
                IDataReader ireader = icmd.ExecuteReader();
                while (ireader.Read())
                {
                    Console.WriteLine("{0} {1}", ireader.GetString(0), ireader.GetString(1));
                }
                iconnection.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }
    }
}
