using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace DataAdapterExample
{
    class Program
    {
        static void Main(string[] args)
        {
            DataSet ds = new DataSet();

            SqlDataAdapter daOsoba = new SqlDataAdapter(
                "SELECT ID, Imie, Nazwisko, Pensja FROM Osoba",
                "Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true"
                );

            SqlDataAdapter daJednostka = new SqlDataAdapter(
                "SELECT ID, Nazwa FROM Jednostka",
                "Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true"
                );

            daOsoba.MissingSchemaAction = MissingSchemaAction.Add;
            daOsoba.FillSchema(ds, SchemaType.Source, "Osoba");
            daOsoba.Fill(ds, "Osoba");

            daJednostka.MissingSchemaAction = MissingSchemaAction.AddWithKey;
            daJednostka.FillSchema(ds, SchemaType.Source, "Jednostka");
            daJednostka.Fill(ds, "Jednostka");

            //ds.Tables["Osoba"].Rows.Add(10, "Jerzy", "Kolanko", 2200);
            //ds.Tables["Jednostka"].Rows.Add(10, "Landek");

            foreach (DataTable t in ds.Tables)
            {
                Console.WriteLine(t.TableName);
                Console.WriteLine("SCHEMAT");
                foreach (DataColumn c in t.Columns)
                {
                    Console.WriteLine(string.Format(
                        "Name: {0}\t Type: {1}\t MaxLen: {2}\t AllowNulls?: {3}",
                        c.ColumnName, c.DataType, c.MaxLength, c.AllowDBNull));
                }
                Console.WriteLine("DANE");
                foreach (DataRow r in t.Rows)
                {
                    foreach (DataColumn c in t.Columns)
                    {
                        Console.Write(r[c] + ", ");
                    }
                    Console.WriteLine();
                }

                Console.WriteLine("---------------------------------------------------------------------");
            }

            Console.ReadLine();
        }
    }
}
