/* Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null primary key, Nazwa varchar(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int references Jednostka(ID), Imie varchar(30), Nazwisko varchar(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

*/
 
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace DataAdapterUpdates2
{
    class Program
    {
        private static void PrintDataTable(DataTable dt)
        {
            foreach (DataRow r in dt.Rows)
            {
                foreach (DataColumn c in dt.Columns)
                {
                    if (r.RowState != DataRowState.Deleted)
                        Console.Write(r[c] + "\t");
                }
                Console.WriteLine(r.RowState);
            }
            Console.WriteLine();
        }

        static void Main(string[] args)
        {
            SqlDataAdapter da = new SqlDataAdapter(
                "SELECT ID, Imie, Nazwisko, Pensja FROM Osoba",
                "Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true;"
                );
            SqlCommandBuilder cb = new SqlCommandBuilder(da);
            da.RowUpdating += new SqlRowUpdatingEventHandler(da_RowUpdating);

            DataTable dt = new DataTable("Osoba");
            da.Fill(dt);
            foreach (DataRow r in dt.Rows)
            {
                if ((int)(r["Pensja"]) < 1650)
                {
                    int x = (int)r["Pensja"];
                    x += 77;
                    r["Pensja"] = x;
                }
                else if ((int)(r["Pensja"]) >= 1900)
                {
                    r.Delete();
                }
            }
            DataRow newRow = dt.NewRow();
            newRow["ID"] = 666;
            newRow["Imie"] = "Johnny";
            newRow["Nazwisko"] = "Szpinak";
            dt.Rows.Add(newRow);

            DataTable dtChanges = dt.GetChanges();
            Console.WriteLine("Tabela ze zmianami:");
            PrintDataTable(dtChanges);

            if (dtChanges != null)
            {
                da.Update(dtChanges);
                dt.AcceptChanges();
            }

            Console.WriteLine("Tabela po zmianach:");
            PrintDataTable(dt);

            Console.ReadLine();
        }

        static void da_RowUpdating(object sender, SqlRowUpdatingEventArgs e)
        {
            Console.WriteLine("Command: "+e.Command.CommandText);
        }
    }
}
