using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace DataSetMerging
{
    class Program
    {
        static void Main(string[] args)
        {
            DataTable OsobaTable = new DataTable("Osoba");
            OsobaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            OsobaTable.Columns.Add("Nazwisko", Type.GetType("System.String"));
            OsobaTable.Columns.Add("Imie", Type.GetType("System.String"));

            OsobaTable.PrimaryKey = new DataColumn[] { OsobaTable.Columns["ID"] };

            OsobaTable.Columns["ID"].AutoIncrement = true;
            OsobaTable.Columns["ID"].AutoIncrementSeed = 1;
            OsobaTable.Columns["ID"].ReadOnly = true;

            OsobaTable.Rows.Add(1, "Kowalski", "Jan");
            OsobaTable.Rows.Add(2, "Nowak", "Elbieta");
            OsobaTable.Rows.Add(3, "Malinowski", "Marek");
            OsobaTable.Rows.Add(4, "Smith", "John");


            DataTable Osoba2Table = new DataTable("Osoba2");
            Osoba2Table.Columns.Add("ID", Type.GetType("System.Int32"));
            Osoba2Table.Columns.Add("Nazwisko", Type.GetType("System.String"));
            Osoba2Table.Columns.Add("Imie", Type.GetType("System.String"));

            Osoba2Table.PrimaryKey = new DataColumn[] { Osoba2Table.Columns["ID"] };

            Osoba2Table.Columns["ID"].AutoIncrement = true;
            Osoba2Table.Columns["ID"].AutoIncrementSeed = 1;
            Osoba2Table.Columns["ID"].ReadOnly = true;

            Osoba2Table.Rows.Add(5, "Kowalski2", "Jan");
            Osoba2Table.Rows.Add(6, "Nowak2", "Elbieta");
            Osoba2Table.Rows.Add(7, "Malinowski2", "Marek");
            Osoba2Table.Rows.Add(8, "Smith2", "John");


            DataTable InnaOsobaTable = new DataTable("Osoba");
            InnaOsobaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            InnaOsobaTable.Columns.Add("NazwiskoImie", Type.GetType("System.String"));

            InnaOsobaTable.PrimaryKey = new DataColumn[] { InnaOsobaTable.Columns["ID"] };

            InnaOsobaTable.Columns["ID"].AutoIncrement = true;
            InnaOsobaTable.Columns["ID"].AutoIncrementSeed = 1;
            InnaOsobaTable.Columns["ID"].ReadOnly = true;

            InnaOsobaTable.Rows.Add(1, "Kowalski Jan");
            InnaOsobaTable.Rows.Add(6, "Nowak Elbieta");
            InnaOsobaTable.Rows.Add(7, "Malinowski Marek");
            InnaOsobaTable.Rows.Add(8, "Smith John");

            DataRow[] rows = new DataRow[InnaOsobaTable.Rows.Count];
            for (int i=0; i<rows.Length; i++)
            {
                rows[i] = InnaOsobaTable.Rows[i];
            }
            DataSet ds = new DataSet();
            ds.Tables.Add(OsobaTable);
            ds.Merge(rows);
            //ds.Merge(InnaOsobaTable, false, MissingSchemaAction.Ignore);

            foreach (DataTable t in ds.Tables)
            {
                Console.WriteLine(t.TableName+":"+t.Rows.Count);
                foreach (DataRow r in t.Rows)
                {
                    foreach (DataColumn c in t.Columns)
                    {
                        Console.Write(r[c]+", ");
                    }
                    Console.WriteLine();
                }
            }
            Console.ReadLine();
        }
    }
}
