/* Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null primary key, Nazwa varchar(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int references Jednostka(ID), Imie varchar(30), Nazwisko varchar(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

select * from Osoba o, Jednostka j where o.ID_Jednostka = j.ID; 

drop procedure sp_dodaj
create procedure sp_dodaj @arg1 int = 0, @arg2 int = 0
as
begin
  select @arg1+@arg2
end

exec sp_dodaj 2, 5

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Configuration;
using System.Xml;

namespace ExecuteCommands
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection = new SqlConnection(ConfigurationManager.AppSettings["sqlconnectionstring"]);
            connection.Open();
            SqlCommand cmd1 = new SqlCommand();
            cmd1.Connection = connection;

            // Uycie ExecuteScalar
            cmd1.CommandText = "SELECT COUNT(*) FROM Osoba";
            Console.WriteLine(cmd1.ExecuteScalar());

            // Uycie ExecuteXmlReader
            cmd1.CommandText = "SELECT * FROM Osoba FOR XML AUTO, XMLDATA";
            XmlReader reader = cmd1.ExecuteXmlReader();
            while (reader.Read())
            {
                Console.WriteLine(reader.ReadOuterXml());
            }
            
            // Uycie ExecuteReader i CommandBehavior.SingleRow
            cmd1.CommandText = "SELECT Nazwisko, Imie FROM Osoba";
            SqlDataReader dr1 = cmd1.ExecuteReader(CommandBehavior.SingleRow);
            while (dr1.Read())
            {
                Console.WriteLine(string.Format("{0} {1}", dr1["Nazwisko"], dr1["Imie"]));
            }
            dr1.Close();

            // Uycie ExecuteReader i CommandBehavior.SingleResult
            cmd1.CommandText = "SELECT Nazwisko, Imie FROM Osoba WHERE ID=1; SELECT Nazwisko, Imie FROM Osoba WHERE ID=2";
            SqlDataReader dr2 = cmd1.ExecuteReader(CommandBehavior.SingleResult); // Odpalamy bez i z parametrem
            do
            {
                while (dr2.Read())
                {
                    Console.WriteLine(string.Format("{0} {1}", dr2["Nazwisko"], dr2["Imie"]));
                }
            } while (dr2.NextResult());
            dr2.Close();

            cmd1.CommandText = "SELECT ID, Nazwisko, Imie, Pensja FROM Osoba";
            SqlDataReader dr3 = cmd1.ExecuteReader(CommandBehavior.SchemaOnly);
            DataTable dt = dr3.GetSchemaTable();
            for (int i=0; i<dt.Rows.Count; i++)
            {
                Console.WriteLine(string.Format("Nazwa: {0}; Typ: {1}; Rozmiar: {2}",
                    dt.Rows[i]["ColumnName"], dt.Rows[i]["DataType"], dt.Rows[i]["ColumnSize"]));
            }

            /* Ponisze wydrukuje 
            foreach (DataRow myField in dt.Rows)
            {
                foreach (DataColumn myProperty in dt.Columns)
                {
                    Console.WriteLine(myProperty.ColumnName + " = " + myField[myProperty].ToString());
                }
                Console.WriteLine();
                //Console.ReadLine();
            }
            */

            while (dr3.Read()) { Console.WriteLine("---------"); } // nic nie wydrukuje
            dr3.Close();

            cmd1.CommandText = "SELECT ID, Nazwisko, Imie, Pensja FROM Osoba";
            SqlDataReader dr4 = cmd1.ExecuteReader(CommandBehavior.KeyInfo);
            dr4.Close();

            // Uycie ExecuteReader i CommandBehavior.CloseConnection
            cmd1.CommandText = "SELECT * FROM Osoba";
            SqlDataReader dr5 = cmd1.ExecuteReader(CommandBehavior.CloseConnection);
            dr1.Close();

            if (connection.State == ConnectionState.Closed) Console.WriteLine("Zamkniete");

            Console.ReadLine();

        }
    }
}
