/* Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null primary key, Nazwa varchar(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int references Jednostka(ID), Imie varchar(30), Nazwisko varchar(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

select * from Osoba o, Jednostka j where o.ID_Jednostka = j.ID; 


drop procedure sp_dodaj
create procedure sp_dodaj @arg1 int = 0, @arg2 int = 0
as
begin
  select @arg1+@arg2
end

exec sp_dodaj

drop procedure GetPersons;
CREATE PROCEDURE GetPersons @lastname varchar(50), @count int output
AS
BEGIN
	SELECT ID, Nazwisko, Imie, Pensja FROM Osoba WHERE Nazwisko LIKE @lastname
	SELECT @count=COUNT(*) FROM Osoba WHERE Nazwisko LIKE @lastname
END

declare
  @x int;
begin
  exec GetPersons 'A%', @x out;
  print @x;
end
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Configuration;

namespace ExecuteCommands2
{
    class Program
    {
        public int x;
        public static Program CreateInstance
        {
            get { return new Program(); }
        }
        static void Main(string[] args)
        {
            SqlConnection conn = new SqlConnection(ConfigurationManager.AppSettings["sqlconnectionstring"]);
            SqlCommand cmd1 = new SqlCommand("SELECT * FROM Osoba WHERE Nazwisko LIKE @nazwisko", conn);
            cmd1.Parameters.Add(new SqlParameter("@nazwisko", SqlDbType.VarChar, 50)).Value = "A%";
            conn.Open();
            SqlDataReader reader = cmd1.ExecuteReader();
            while (reader.Read())
            {
                Console.WriteLine("{0} {1}", reader["Nazwisko"], reader["Imie"]);
            }
            reader.Close();

            Console.WriteLine("--------------");

            SqlCommand cmd2 = new SqlCommand("SELECT * FROM Osoba WHERE Imie LIKE @imie; " +
                "SELECT @count = COUNT(*) FROM Osoba WHERE Imie LIKE @imie", conn);
            cmd2.Parameters.Add(new SqlParameter("@imie", SqlDbType.VarChar, 50)).Value = "A%";
            cmd2.Parameters.Add(new SqlParameter("@count", SqlDbType.Int));
            cmd2.Parameters["@count"].Direction = ParameterDirection.Output;
            SqlDataReader reader2 = cmd2.ExecuteReader();
            while (reader2.Read())
            {
                Console.WriteLine("{0} {1}", reader2["Nazwisko"], reader2["Imie"]);
            }
            reader2.Close();
            Console.WriteLine("{0} {1}", "Count: ", cmd2.Parameters["@count"].Value.ToString());

            Console.WriteLine("--------------");

            SqlConnection connection = new SqlConnection(ConfigurationManager.AppSettings["sqlconnectionstring"]);
            SqlCommand cmd = new SqlCommand();
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = "sp_dodaj";
            cmd.Parameters.Add(new SqlParameter("arg1", 4));
            cmd.Parameters.Add(new SqlParameter("arg2", 11));
            cmd.Connection = connection;
            connection.Open();
            Console.WriteLine(string.Format("{0}", cmd.ExecuteScalar()));
            connection.Close();

            Console.WriteLine("--------------");

            SqlCommand cmd3 = new SqlCommand("GetPersons", conn);
            cmd3.CommandType = CommandType.StoredProcedure;
            cmd3.Parameters.Add(new SqlParameter("@lastname", SqlDbType.VarChar, 50)).Value = "A%";
            cmd3.Parameters.Add(new SqlParameter("@count", SqlDbType.Int));
            cmd3.Parameters["@count"].Direction = ParameterDirection.Output;
            SqlDataReader reader3 = cmd3.ExecuteReader();
            while (reader3.Read())
            {
                Console.WriteLine("{0} {1}", reader3["Nazwisko"], reader3["Imie"]);
            }
            reader3.Close();
            Console.WriteLine("{0} {1}", "Count: ", cmd3.Parameters["@count"].Value.ToString());
            conn.Close();

            Console.ReadLine();
        }
    }
}
