/* Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

declare
  @lastid int;

create table Jednostka(
  ID int not null primary key identity,
  Nazwa varchar(20)
);

begin
  delete from Jednostka;
  insert into Jednostka( Nazwa ) values( 'Wrocaw' );
  insert into Jednostka( Nazwa ) values( 'Pozna' );
  insert into Jednostka( Nazwa ) values( 'Krakw' );
  insert into Jednostka( Nazwa ) values( 'Warszawa' );
  select @lastid=@@identity from Jednostka;
  update Sekwencje set Liczba=@lastid+1 where Tabela='Jednostka';
end;

create table Osoba(
  ID int not null primary key identity,
  ID_Jednostka int references Jednostka(ID),
  Imie varchar(30),
  Nazwisko varchar(50),
  Pensja int
)

begin
  delete from Osoba;
  insert into Osoba values( 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 3, 'Stan', 'Taczkowski', 1900 );
  select @lastid=@@identity from Osoba;
  update Sekwencje set Liczba=@lastid+1 where Tabela='Osoba';
end;

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsExample3
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection = new SqlConnection("Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true");
            SqlTransaction transaction = null;
            try
            {
                connection.Open();
                transaction = connection.BeginTransaction();

                SqlCommand cmd = new SqlCommand();
                cmd.Connection = connection;
                cmd.Transaction = transaction;
                
                cmd.CommandText = "INSERT INTO Jednostka (Nazwa) VALUES ('Kalisz')";
                cmd.ExecuteNonQuery();
                
                cmd.CommandText = "SELECT @@identity FROM Jednostka";
                string IdJednostki = (string)cmd.ExecuteScalar().ToString();

                for (int i = 0; i < 10; i++)
                {
                    cmd.CommandText = string.Format("INSERT INTO Osoba VALUES({0}, '{1}', '{2}', {3})", IdJednostki, "Jan" + i, "Kowalski" + i, 1600 + i);
                    cmd.ExecuteNonQuery();
                }

                transaction.Commit();
            }
            catch (Exception e)
            {
                transaction.Rollback();
                Console.WriteLine("AWARIA");
                Console.WriteLine(e.Message);
            }
            finally
            {
                connection.Close();
            }
            Console.WriteLine("OK");
            Console.ReadLine();
        }
    }
}
