using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace WADatabaseDataSource2b
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            SqlConnection connection = new SqlConnection("Data Source=DRACULA\\SQLEXPRESS; Initial Catalog=KursPBD; Integrated Security=true");

            DataSet ds = new DataSet("Database");
            DataTable dtJednostka = new DataTable("Jednostka");
            SqlDataAdapter daJednostka = new SqlDataAdapter(
                "SELECT Id, Nazwa FROM Jednostka",
                connection
            );
            ds.Tables.Add(dtJednostka);
            daJednostka.Fill(dtJednostka);

            DataTable dtOsoba = new DataTable("Osoba");
            SqlDataAdapter daOsoba = new SqlDataAdapter(
                "SELECT Id, Id_Jednostka, Imie, Nazwisko FROM Osoba",
                connection
            );
            ds.Tables.Add(dtOsoba);
            daOsoba.Fill(dtOsoba);

            ds.Relations.Add(new DataRelation(
                "R_Jednostka_Osoba",
                dtJednostka.Columns["Id"],
                dtOsoba.Columns["Id_Jednostka"],
                true));

            BindingSource jednostkaBindingSource = new BindingSource(ds, "Jednostka");
            BindingSource osobaBindingSource = new BindingSource(jednostkaBindingSource, "R_Jednostka_Osoba");

            jednostkaBindingNavigator.BindingSource = jednostkaBindingSource;
            osobaBindingNavigator.BindingSource = osobaBindingSource;

            DataGridViewTextBoxColumn jednostkaColumnNazwa = new DataGridViewTextBoxColumn();
            jednostkaColumnNazwa.DataPropertyName = "Nazwa";
            jednostkaColumnNazwa.Name = "Nazwa";

            jednostkaDataGridView.AutoGenerateColumns = false;
            jednostkaDataGridView.Columns.Add(jednostkaColumnNazwa);

            DataGridViewTextBoxColumn osobaColumnImie = new DataGridViewTextBoxColumn();
            osobaColumnImie.DataPropertyName = "Imie";
            osobaColumnImie.Name = "Imie";
            osobaColumnImie.HeaderText = "Imi";

            DataGridViewTextBoxColumn osobaColumnNazwisko = new DataGridViewTextBoxColumn();
            osobaColumnNazwisko.DataPropertyName = "Nazwisko";
            osobaColumnNazwisko.Name = "Nazwisko";

            osobaDataGridView.AutoGenerateColumns = false;
            osobaDataGridView.Columns.AddRange(new DataGridViewColumn[] {
                osobaColumnImie, osobaColumnNazwisko});

            jednostkaDataGridView.DataSource = jednostkaBindingSource;
            osobaDataGridView.DataSource = osobaBindingSource;
        }
    }
}